#ifndef APPWINDOW_HPP
#define APPWINDOW_HPP

#include <gtkmm.h>
#include <sstream>
#include "viewer.hpp"

class AppWindow : public Gtk::Window {
public:
  AppWindow();
  
protected:

private:
  // A "vertical box" which holds everything in our window
  Gtk::VBox m_vbox;

  // The menubar, with all the menus at the top of the window
  Gtk::MenuBar m_menubar;
  // Each menu itself
  Gtk::Menu m_menu_app;
  Gtk::Menu m_menu_mode;

  Gtk::Label m_status_label;
  Gtk::Label m_status_clip_near;
  Gtk::Label m_status_clip_far;

  // The main OpenGL area
  Viewer m_viewer;

  void set_mode(Viewer::Mode aMode);
  void reset();
  bool set_clip_status();
  void set_clip_status_near();
  void set_clip_status_far();
};

#endif
